"{ Package: 'jv:cface' }"

"{ NameSpace: Cface }"

TypeMapping subclass:#CairoMapping
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Cface-Mappings'
!


!CairoMapping methodsFor:'accessing'!

smalltalkClassNameForDerivedType:cType 
    |cairoName|

    cairoName := cType cName.
    cairoName = '_cairo' ifTrue:[
        ^ #GraphicsContext
    ].
    (cairoName startsWith:'_cairo_') ifTrue:[
        cairoName := cairoName copyFrom:8
    ].
    (cairoName startsWith:'cairo_') ifTrue:[
        cairoName := cairoName copyFrom:7
    ].
    (cairoName endsWith:'_t') ifTrue:[
        cairoName := cairoName copyTo:(cairoName size - 2)
    ].
    ^ (self smalltalkize:cairoName) capitalized asSymbol

    "
        Cface::CairoMappings new
            classForType:(Cface::EnumNode new name:'_cairo_subpixel_order_t')

        Cface::CairoMappings new
            classForType:(Cface::EnumNode new name:'_cairo_status_t')"
    "Answers class which should contain function call"

    "Modified: / 17-02-2008 / 22:18:24 / janfrog"
    "Created: / 10-07-2008 / 08:05:42 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

smalltalkNamespace

    ^#Cairo

    "Created: / 17-02-2008 / 20:51:26 / janfrog"
!

smalltalkPackage

    ^#'stx:goodies/libcairo'

    "Created: / 03-07-2008 / 21:14:47 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

smalltalkSelectorForFunction: cFunction

    ^String streamContents:
        [:s|
        s nextPutAll:cFunction cName.
        cFunction arguments notEmptyOrNil ifTrue:
            [s nextPut:$:].
        cFunction arguments size > 1 ifTrue:
            [(cFunction arguments copyFrom:2) do:
                [:argument|
                s 
                    nextPutAll: '_:']]]

    "Created: / 17-02-2008 / 22:16:03 / janfrog"
    "Modified: / 18-02-2008 / 14:58:43 / janfrog"
    "Modified: / 04-07-2008 / 15:33:31 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 28-12-2014 / 10:25:59 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CairoMapping methodsFor:'mapping - class names'!

smalltalkClassNameForFunction:cFunction 
    ^ 'CPrimitives'

    "Created: / 28-12-2014 / 20:41:38 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CairoMapping class methodsFor:'documentation'!

version
    ^ '$Id$'
!

version_SVN
    ^ '$Id$'
! !

